#include <time.h>
#include <iostream.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include "CifBuilder.h"

int main(int argc, char ** argv) {
  if (argc != 3) {
    cerr << "Usage: " << argv[0] << " Filename DatablockName" << endl;
    exit(0);
  }
  CifBuilder cb(argv[1]);
  cb.BuildDictionaryList();
  cb.SetContext(argv[2]);

  cout << "Get the all the dictionaries in one sweep ... " << endl << endl;
  cb.GetAllDictionaries();
  cout << "Done!" << endl;
  exit(0);
}





