
#include "CifViewObj.h"
#include <iostream.h>


#define FALSE 0
void main() {
  char *diags=NULL;
  CifFileObj * fobjR = NULL;
  ISTable *t=NULL;

  CifViewObj * vobj = NULL;
  ReVarCifArray<CifString>  *cats=NULL, *viewItems=NULL;
  ReVarCifArray<CifString>  *viewItems1=NULL;
  int   *ind = NULL;
  CifString cs;
  int i,j, iAdd;
  //  int icur, imax, istatus;

  fobjR = new CifFileObj("./test/TESTFILE2", WRITE_MODE, 80, "?", 1);
  fobjR->Read("./test/1ayl.cif",diags);
  if (diags) cout << " Diagnostics [" << strlen(diags) << "] " << diags << endl;


  vobj = new CifViewObj("./test/view1.cif", "./test/TESTFILE1", "view1", 1);
  cerr << "View Diagnostics " << vobj->GetViewDiagnostics() << endl;

  vobj->Write("./test/view1.oxcif");

  cs.Copy("?");

  cats = vobj->GetCategoriesViewable();


  for (i=0; i < cats->Length(); i++) {
    cerr << "Category " << (*cats)[i].Text() << endl;
    if (fobjR->IsTablePresent("1AYL", (*cats)[i].Text())) continue;
    t = new ISTable((*cats)[i].Text());
    iAdd=vobj->AddMissingTable(t, cs);
    cerr << "iAdd = " << iAdd << endl;
    if (iAdd > 0) {
      cerr << "              Num rows is " << t->GetNumRows() << " Num Columns is " << t->GetNumColumns() << endl;
      fobjR->WriteTable(t,"1AYL", (*cats)[i].Text());
      cerr << "             Wrote table with "<< iAdd << " columns"<<endl;
    }
  }
  fobjR->CloseFile();

  fobjR = new CifFileObj("./test/TESTFILE2", APPEND_MODE);

  for (i=0; i < cats->Length(); i++) {
    cerr << "Category " << (*cats)[i].Text() << endl;
    t = fobjR->GetTablePtr("1AYL", (*cats)[i].Text());
    if (!t) continue;

    iAdd=vobj->FixMissingColumns(t, cs);
    cerr << "iAdd = " << iAdd << endl;
    if (iAdd > 0) {
      if (!t) cerr << "      ------ Table is null ------ " << endl;
      cerr << "              Num rows is " << t->GetNumRows() << " Num Columns is " << t->GetNumColumns() << endl;
      fobjR->WriteTable(t,"1AYL", (*cats)[i].Text());
      cerr << "             Wrote table and added "<< iAdd << " columns"<<endl;

    }
  }
  //  fobjR->CloseFile();


  vobj->Write("./test/view-tmp.ocif");
  cerr << "Wrote view and state" << endl;

  //  fobjR = new CifFileObj("./test/TESTFILE2", APPEND_MODE);
  //  fobjR->PrintHeaderInfo();

#if 0
  cerr << "Updating state" << endl;
  vobj->UpdateCategoryState(fobjR,"1AYL");
#endif


  //  fobjR->PrintHeaderInfo();
  CifString * tCS = NULL;
  for (i=0; i < cats->Length(); i++) {
    cout << "Category " << (*cats)[i].Text() << " index "<< vobj->GetCategoryIndex((*cats)[i].Text()) << endl;
    tCS = vobj->GetViewCategory((*cats)[i].Text());
    cout << "View category " << tCS->Text() << " index "<< vobj->GetViewCategoryIndex(tCS->Text()) << endl;
    if (tCS) delete tCS;
  }

  for (i=0; i < cats->Length(); i++) {
    t = fobjR->GetTablePtr("1AYL", (*cats)[i].Text());
    if (!t) {
      cerr << (*cats)[i].Text() << " is null" << endl;
      continue;
    }

    cerr << " ------- All Items in Category " << (*cats)[i].Text() << endl;
    ind=vobj->GetItemColumnIndices(t);
    if (ind) {
      viewItems=vobj->GetCategoryItems((*cats)[i].Text());
      for (j=0; j < viewItems->Length(); j++) {
	cerr << "j " << j << " "<< (*viewItems)[j].Text() << " ind[j] " << ind[j] << endl;
      }
      if (viewItems) delete viewItems;
    }
    if (ind) delete[] ind; 

#if 0
    cerr << " ------- ViewableItems in Category " << (*cats)[i].Text() << endl;
    viewItems1=vobj->GetCategoryItemsViewable((*cats)[i].Text());
    ind = vobj->GetItemColumnIndices(t, viewItems1);
    if (ind) delete[] ind;

    if (viewItems1) delete viewItems1;    
    viewItems1=vobj->GetCategoryItemsViewable((*cats)[i].Text());
    ind = vobj->GetItemColumnIndices(t, viewItems1);
    if (ind) delete[] ind;

    if (viewItems1) delete viewItems1;    
    viewItems1=vobj->GetCategoryItemsViewable((*cats)[i].Text());
    if (viewItems1) delete viewItems1;    

    cerr << " ------- Mandatory Items in Category " << (*cats)[i].Text() << endl;
    viewItems1=vobj->GetCategoryItemsViewable((*cats)[i].Text());
    if (viewItems1) delete viewItems1;    
    cerr << " ------- Mandatory Items in Category " << (*cats)[i].Text() << endl;
    viewItems1=vobj->GetCategoryItemsViewable((*cats)[i].Text());
    if (viewItems1) delete viewItems1;    
    cerr << " ------- Mandatory Items in Category " << (*cats)[i].Text() << endl;
    viewItems1=vobj->GetCategoryItemsViewable((*cats)[i].Text());
    if (viewItems1) delete viewItems1;    
#endif

    cerr << " ------- Mandatory Items in Category " << (*cats)[i].Text() << endl;
    viewItems1=vobj->GetCategoryItemsMandatory((*cats)[i].Text());
    if (viewItems1 && viewItems1->Length() > 0) {
      ind = vobj->GetItemColumnIndices(t, viewItems1);
      for (j=0; j < viewItems1->Length(); j++) {
	cerr << "j " << j << " "<< (*viewItems1)[j].Text() << " ind[j] " << ind[j] << endl;
      }
      if (ind) delete[] ind;
    }
    if (viewItems1) delete viewItems1;

    cerr << " ------- Viewable Items in Category " << (*cats)[i].Text() << endl;
    viewItems1=vobj->GetCategoryItemsViewable((*cats)[i].Text());
    if (viewItems1 && viewItems1->Length() > 0) {
      ind = vobj->GetItemColumnIndices(t, viewItems1);
      if (ind != NULL) {
	for (j=0; j < viewItems1->Length(); j++) {
	  cerr << "j " << j << " "<< (*viewItems1)[j].Text() << " ind[j] " << ind[j] << endl;
	}
	if (ind) delete[] ind;
      } else {
	cerr << "********************* Index list is NULL" << endl;
      }
      
    }
    if (viewItems1) delete viewItems1;


  }

  if (cats) delete cats;
#if 0
  cats = vobj->GetCategoriesViewable();
  for (j=0; j < 10; j++) {
    for (i=0; i < cats->Length(); i++) {
      icur=vobj->GetStateRowCurrent((*cats)[i].Text());
      imax=vobj->GetStateRowMaximum((*cats)[i].Text());
      istatus=vobj->GetStateStatus((*cats)[i].Text());
      //      cerr << "** Current row " << icur << " Maximum row " << imax << " Status " << istatus << endl;
      icur++;
      imax++;
      istatus++;
      vobj->SetStateRowCurrent((*cats)[i].Text(), icur);
      vobj->SetStateRowMaximum((*cats)[i].Text(), imax);
      vobj->SetStateStatus((*cats)[i].Text(), istatus);
    }
  }
#endif

  fobjR->Write("1ayl.ocif");
  fobjR->CloseFile();
  vobj->Close();
  if (vobj) delete vobj;
  if (fobjR) delete fobjR;
  //
  vobj = new CifViewObj("./test/TESTFILE1", "view1", 0);
  vobj->Write("./test/view-tmp-2.ocif");
  if (vobj) delete vobj;
  //
  exit(0);
}
